/*
Tetris for Zx3
(C) 2010 Jeroen Domburg (jeroen AT spritesmods.com)

This program is free software: you can redistribute it and/or modify
t under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
	    
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
			    
You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "playfield.h"


//lame, copypasted from somewhere, but works
void* memcpy(void* dest, const void* src, int count) {
        char* dst8 = (char*)dest;
        char* src8 = (char*)src;

        while (count--) {
            *dst8++ = *src8++;
        }
        return dest;
    }

//Routines to play Tetris. I'm too lame to document them now; if you 
//are interested in reverse engineering, you probably have no problem figuring
//out what these do yourself :P


void fieldClear(playfield_t *field) {
	int x,y;
	for (x=0; x<10; x++) {
		for (y=0; y<20; y++) {
			field->field[x][y]=0;
		}
	}
	for (x=0; x<4; x++) {
		for (y=0; y<4; y++) {
			field->currBlock[x][y]=0;
		}
	}
}

int fieldIsPossible(playfield_t *field) {
	int px,py;
	int x,y;
	for (x=0; x<4; x++) {
		for (y=0; y<4; y++) {
			if (field->currBlock[x][y]!=0) {
				px=x+field->currBlockX;
				py=y+field->currBlockY;
				if (px<0 || px>=10 || py>=20) return 0;
				if (py>=0 && field->field[px][py]!=0) return 0;
			}
		}
	}
	return 1;
}


void fieldDup(playfield_t *dest, playfield_t *src) {
	memcpy(dest, src, sizeof(playfield_t));
}

void fieldRotateBlk(playfield_t *field, int dir) {
	unsigned char buff[4][4];
	int x,y;
	for (x=0; x<4; x++) {
		for (y=0; y<4; y++) {
			buff[x][y]=field->currBlock[x][y];
		}
	}
	for (x=0; x<4; x++) {
		for (y=0; y<4; y++) {
			if (dir>0) {
				field->currBlock[x][y]=buff[3-y][x];
			} else {
				field->currBlock[x][y]=buff[y][3-x];
			}
		}
	}
}



void fieldSelectBlk(playfield_t *field, int blkNo) {
	int x,y;
	const unsigned char availBlocks[7][4][4]={
		{
			{0,0,0,0},
			{0,0,0,0},
			{1,1,1,1},
			{0,0,0,0},
		}, {
			{0,0,0,0},
			{2,2,2,0},
			{0,0,2,0},
			{0,0,0,0},
		}, {
			{0,0,0,0},
			{0,3,3,3},
			{0,3,0,0},
			{0,0,0,0},
		}, {
			{0,0,0,0},
			{0,4,4,0},
			{0,4,4,0},
			{0,0,0,0},
		}, {
			{0,0,0,0},
			{0,5,5,0},
			{5,5,0,0},
			{0,0,0,0},
		}, {
			{0,0,0,0},
			{0,6,6,0},
			{0,0,6,6},
			{0,0,0,0},
		}, {
			{0,0,0,0},
			{0,7,7,7},
			{0,0,7,0},
			{0,0,0,0},
		}
	};
	for (x=0; x<4; x++) {
		for (y=0; y<4; y++) {
			field->currBlock[x][y]=availBlocks[blkNo][x][y];
		}
	}
	field->currBlockX=3;
	field->currBlockY=-2;
}


static int checkAndKillALine(playfield_t *field) {
	int x,y,ry;
	int found;
	for (y=0; y<20; y++) {
		found=1;
		for (x=0; x<10; x++) {
			if (field->field[x][y]==0) found=0;
		}
		if (found) {
			//Remove line
			for (ry=y; ry>=0; ry--) {
				for (x=0; x<10; x++) {
					if (ry!=0) {
						field->field[x][ry]=field->field[x][ry-1];
					} else {
						field->field[x][ry]=0;
					}
				}
			}
			return 1;
		}
	}
	return 0;
}

int fieldFixBlock(playfield_t *field) {
	int px,py;
	int x,y;
	for (x=0; x<4; x++) {
		for (y=0; y<4; y++) {
			px=x+field->currBlockX; py=y+field->currBlockY;
			if (field->currBlock[x][y]!=0) field->field[px][py]=field->currBlock[x][y];
		}
	}
	while (checkAndKillALine(field)) ; //todo: increment score?
	return 1;
}
